<?php
/* Autor...: Grupo Deltron S.A. */
/* Esquema.: modelo_llamadas_nhc_5.xml */
/* Generado: 2014-11-25 12:53:02 */

/* Busqueda de registros de la tabla cr_llamada_movimiento. */
abstract class BaseCr_llamada_movimientoFN extends Cr_llamada_movimientoBN
{
    /* Declaracion de constantes */
    const IdMovimientoLlamada = "IDMOVIMIENTOLLAMADA";
    const IdCabecera = "IDCABECERA";
    const IdTelefono = "IDTELEFONO";
    const IdCliente = "IDCLIENTE";
    const IdResultado = "IDRESULTADO";
    const Detalle = "DETALLE";
    const Fecha = "FECHA";
    const Monto = "MONTO";
    const HoraMinutoFin = "HORAMINUTOFIN";
    const HoraMinutoInicio = "HORAMINUTOINICIO";
    const TipoPago = "TIPOPAGO";
    const Banco = "BANCO";
    const Estado = "ESTADO";
    const FechaRegistro = "FECHAREGISTRO";
    const UsuarioRegistro = "USUARIOREGISTRO";
    const Eliminado = "ELIMINADO";
    const FechaEliminado = "FECHAELIMINADO";
    const UsuarioEliminado = "USUARIOELIMINADO";

    public $a_Condition = array();
    public $a_OrderBy = array();

    /* Obtiene una conexion a la base de datos */
    public function getConnect()
    {
        $o_DBConnect = Conexion::getConexion();
        //$o_Resource = $o_DBConnect->getResource();
        return $o_DBConnect;
    }

    /* Obtiene la cadena de columas */
    public function getSelectColumns()
    {
        $s_SQLQuery = "IdMovimientoLlamada AS IdMovimientoLlamada, ";
        $s_SQLQuery .= "IdCabecera AS IdCabecera, ";
        $s_SQLQuery .= "IdTelefono AS IdTelefono, ";
        $s_SQLQuery .= "IdCliente AS IdCliente, ";
        $s_SQLQuery .= "IdResultado AS IdResultado, ";
        $s_SQLQuery .= "Detalle AS Detalle, ";
        $s_SQLQuery .= "Fecha AS Fecha, ";
        $s_SQLQuery .= "Monto AS Monto, ";
        $s_SQLQuery .= "HoraMinutoFin AS HoraMinutoFin, ";
        $s_SQLQuery .= "HoraMinutoInicio AS HoraMinutoInicio, ";
        $s_SQLQuery .= "TipoPago AS TipoPago, ";
        $s_SQLQuery .= "Banco AS Banco, ";
        $s_SQLQuery .= "Estado AS Estado, ";
        $s_SQLQuery .= "FechaRegistro AS FechaRegistro, ";
        $s_SQLQuery .= "UsuarioRegistro AS UsuarioRegistro, ";
        $s_SQLQuery .= "Eliminado AS Eliminado, ";
        $s_SQLQuery .= "FechaEliminado AS FechaEliminado, ";
        $s_SQLQuery .= "UsuarioEliminado AS UsuarioEliminado ";
        return $s_SQLQuery;
    }

    /* Establece el condicion de filtro de la lista resultante */
    public function addCondition( $s_Const, $s_Operator, $u_Value )
    {
        $this->a_Condition[] = array( "COLUMN" => $s_Const, "OPERATOR" => $s_Operator, "VALUE" => $u_Value );
    }

    /* Establece el orden de la lista resultante */
    public function addOrderBy( $s_Const, $b_OrderAsc = true )
    {
        $this->a_OrderBy[] = array( "COLUMN" => $s_Const, "ASC" => $b_OrderAsc );
    }

    /* Establece los valores desde un objeto Cr_llamada_movimientoBN */
    public function setByBN( Cr_llamada_movimientoBN $o_Cr_llamada_movimientoBN )
    {
        if ( !is_null( $o_Cr_llamada_movimientoBN->getIdMovimientoLlamada() ) )
        {
            $this->setIdMovimientoLlamada( $o_Cr_llamada_movimientoBN->getIdMovimientoLlamada() );
        }
        if ( !is_null( $o_Cr_llamada_movimientoBN->getIdCabecera() ) )
        {
            $this->setIdCabecera( $o_Cr_llamada_movimientoBN->getIdCabecera() );
        }
        if ( !is_null( $o_Cr_llamada_movimientoBN->getIdTelefono() ) )
        {
            $this->setIdTelefono( $o_Cr_llamada_movimientoBN->getIdTelefono() );
        }
        if ( !is_null( $o_Cr_llamada_movimientoBN->getIdCliente() ) )
        {
            $this->setIdCliente( $o_Cr_llamada_movimientoBN->getIdCliente() );
        }
        if ( !is_null( $o_Cr_llamada_movimientoBN->getIdResultado() ) )
        {
            $this->setIdResultado( $o_Cr_llamada_movimientoBN->getIdResultado() );
        }
        if ( !is_null( $o_Cr_llamada_movimientoBN->getDetalle() ) )
        {
            $this->setDetalle( $o_Cr_llamada_movimientoBN->getDetalle() );
        }
        if ( !is_null( $o_Cr_llamada_movimientoBN->getFecha() ) )
        {
            $this->setFecha( $o_Cr_llamada_movimientoBN->getFecha() );
        }
        if ( !is_null( $o_Cr_llamada_movimientoBN->getMonto() ) )
        {
            $this->setMonto( $o_Cr_llamada_movimientoBN->getMonto() );
        }
        if ( !is_null( $o_Cr_llamada_movimientoBN->getHoraMinutoFin() ) )
        {
            $this->setHoraMinutoFin( $o_Cr_llamada_movimientoBN->getHoraMinutoFin() );
        }
        if ( !is_null( $o_Cr_llamada_movimientoBN->getHoraMinutoInicio() ) )
        {
            $this->setHoraMinutoInicio( $o_Cr_llamada_movimientoBN->getHoraMinutoInicio() );
        }
        if ( !is_null( $o_Cr_llamada_movimientoBN->getTipoPago() ) )
        {
            $this->setTipoPago( $o_Cr_llamada_movimientoBN->getTipoPago() );
        }
        if ( !is_null( $o_Cr_llamada_movimientoBN->getBanco() ) )
        {
            $this->setBanco( $o_Cr_llamada_movimientoBN->getBanco() );
        }
        if ( !is_null( $o_Cr_llamada_movimientoBN->getEstado() ) )
        {
            $this->setEstado( $o_Cr_llamada_movimientoBN->getEstado() );
        }
        if ( !is_null( $o_Cr_llamada_movimientoBN->getFechaRegistro() ) )
        {
            $this->setFechaRegistro( $o_Cr_llamada_movimientoBN->getFechaRegistro() );
        }
        if ( !is_null( $o_Cr_llamada_movimientoBN->getUsuarioRegistro() ) )
        {
            $this->setUsuarioRegistro( $o_Cr_llamada_movimientoBN->getUsuarioRegistro() );
        }
        if ( !is_null( $o_Cr_llamada_movimientoBN->getEliminado() ) )
        {
            $this->setEliminado( $o_Cr_llamada_movimientoBN->getEliminado() );
        }
        if ( !is_null( $o_Cr_llamada_movimientoBN->getFechaEliminado() ) )
        {
            $this->setFechaEliminado( $o_Cr_llamada_movimientoBN->getFechaEliminado() );
        }
        if ( !is_null( $o_Cr_llamada_movimientoBN->getUsuarioEliminado() ) )
        {
            $this->setUsuarioEliminado( $o_Cr_llamada_movimientoBN->getUsuarioEliminado() );
        }
    }

    /* Busca un registro por su llave primaria */
    public function selectByPK( $i_IdMovimientoLlamada )
    {
        if( is_null( $i_IdMovimientoLlamada ) ){ $i_IdMovimientoLlamada = -1; } 
 
        $s_SQLQuery = "SELECT ";
        $s_SQLQuery .= $this->getSelectColumns();
        $s_SQLQuery .= "FROM cr_llamada_movimiento ";
        $s_SQLQuery .= "WHERE IdMovimientoLlamada = ".$i_IdMovimientoLlamada." ";
        $s_SQLQuery .= "LIMIT 1;";

        $o_Cr_llamada_movimientoBN = null;
        $o_Resource = $this->getConnect();
        $o_SQLResult = mysql_query( $s_SQLQuery, $o_Resource );
        if ( $o_SQLResult === false )
        {
            throw new Exception( mysql_error() );
        }
        if ( $a_SQLRow = mysql_fetch_object( $o_SQLResult ) )
        {
            $o_Cr_llamada_movimientoBN = $this->insertObjectBN( $a_SQLRow );
        }
        return $o_Cr_llamada_movimientoBN;
    }

    public function buildConsult()
    {
        $s_SQLQuery = "";
        if ( !is_null( $this->getIdMovimientoLlamada() ) ) $s_SQLQuery .= "IdMovimientoLlamada = ".$this->getIdMovimientoLlamada()." AND ";
        if ( !is_null( $this->getIdCabecera() ) ) $s_SQLQuery .= "IdCabecera = ".$this->getIdCabecera()." AND ";
        if ( !is_null( $this->getIdTelefono() ) ) $s_SQLQuery .= "IdTelefono = ".$this->getIdTelefono()." AND ";
        if ( !is_null( $this->getIdCliente() ) ) $s_SQLQuery .= "IdCliente = ".$this->getIdCliente()." AND ";
        if ( !is_null( $this->getIdResultado() ) ) $s_SQLQuery .= "IdResultado = ".$this->getIdResultado()." AND ";
        if ( !is_null( $this->getDetalle() ) ) $s_SQLQuery .= "Detalle = '".$this->getDetalle()."' AND ";
        if ( !is_null( $this->getFecha() ) ) $s_SQLQuery .= "Fecha = '".$this->getFecha()."' AND ";
        if ( !is_null( $this->getMonto() ) ) $s_SQLQuery .= "Monto = ".$this->getMonto()." AND ";
        if ( !is_null( $this->getHoraMinutoFin() ) ) $s_SQLQuery .= "HoraMinutoFin = ".$this->getHoraMinutoFin()." AND ";
        if ( !is_null( $this->getHoraMinutoInicio() ) ) $s_SQLQuery .= "HoraMinutoInicio = ".$this->getHoraMinutoInicio()." AND ";
        if ( !is_null( $this->getTipoPago() ) ) $s_SQLQuery .= "TipoPago = '".$this->getTipoPago()."' AND ";
        if ( !is_null( $this->getBanco() ) ) $s_SQLQuery .= "Banco = '".$this->getBanco()."' AND ";
        if ( !is_null( $this->getEstado() ) ) $s_SQLQuery .= "Estado = '".$this->getEstado()."' AND ";
        if ( !is_null( $this->getFechaRegistro() ) ) $s_SQLQuery .= "FechaRegistro = '".$this->getFechaRegistro()."' AND ";
        if ( !is_null( $this->getUsuarioRegistro() ) ) $s_SQLQuery .= "UsuarioRegistro = '".$this->getUsuarioRegistro()."' AND ";
        if ( !is_null( $this->getEliminado() ) ) $s_SQLQuery .= "Eliminado = ".$this->getEliminado()." AND ";
        if ( !is_null( $this->getFechaEliminado() ) ) $s_SQLQuery .= "FechaEliminado = '".$this->getFechaEliminado()."' AND ";
        if ( !is_null( $this->getUsuarioEliminado() ) ) $s_SQLQuery .= "UsuarioEliminado = '".$this->getUsuarioEliminado()."' AND ";
        if ( count( $this->a_Condition ) > 0 )
        {
            foreach ( $this->a_Condition as $a_Condition )
            {
                $s_SQLQuery .= $a_Condition[ "COLUMN" ]." ".$a_Condition[ "OPERATOR" ]." '".$a_Condition[ "VALUE" ]."' AND ";
            }
        }
        $s_SQLQuery .= "1 = 1 ";
        return $s_SQLQuery;
    }

    public function selectNumRows()
    {
        $s_SQLQuery = "SELECT ";
        $s_SQLQuery .= "COUNT(*) AS cnt ";
        $s_SQLQuery .= "FROM cr_llamada_movimiento WHERE ";
        $s_SQLQuery .= $this->buildConsult();
        
        $o_Resource = $this->getConnect();
        $o_SQLResult = mysql_query( $s_SQLQuery, $o_Resource );
        if ( $o_SQLResult === false )
        {
            throw new Exception( mysql_error() );
        }
        
        $num_rows = 0;
        if ( $a_SQLRow = mysql_fetch_object( $o_SQLResult ) )
        {
            $num_rows = $a_SQLRow->cnt;
        }
        return $num_rows;
    }

    /* Busca varios registros por los campos establecidos */
    public function select( $i_Position = null, $i_Rows = null )
    {
        $s_SQLQuery = "SELECT ";
        $s_SQLQuery .= $this->getSelectColumns();
        $s_SQLQuery .= "FROM cr_llamada_movimiento WHERE ";
        $s_SQLQuery .= $this->buildConsult();
        if ( count( $this->a_OrderBy ) > 0 )
        {
            $s_SQLQuery = $s_SQLQuery."ORDER BY ";
            $s_Separator = "";
            foreach ( $this->a_OrderBy as $a_OrderBy )
            {
                $s_SQLQuery .= $s_Separator.$a_OrderBy[ "COLUMN" ]." ";
                if ( $a_OrderBy[ "ASC" ] === false ) $s_SQLQuery .= "DESC ";
                $s_Separator = ", ";
            }
        }
        if( !is_null( $i_Position ) && is_null( $i_Rows ) ) $s_SQLQuery .= "LIMIT ".$i_Position;
        if( !is_null( $i_Position ) && !is_null( $i_Rows ) ) $s_SQLQuery .= "LIMIT ".$i_Position.", ".$i_Rows;
        $s_SQLQuery .= ";";

        $a_Cr_llamada_movimientoBN = null;
        $o_Resource = $this->getConnect();
        $o_SQLResult = mysql_query( $s_SQLQuery, $o_Resource );
        if ( $o_SQLResult === false )
        {
            throw new Exception( mysql_error() );
        }
        while ( $a_SQLRow = mysql_fetch_object( $o_SQLResult ) )
        {
            $o_Cr_llamada_movimientoBN = $this->insertObjectBN( $a_SQLRow );
            $a_Cr_llamada_movimientoBN[] = $o_Cr_llamada_movimientoBN;
        }
        return $a_Cr_llamada_movimientoBN;
    }

    /* Devuelve un objeto Cr_llamada_movimientoBN desde un objeto propel */
    public function insertObjectBN( $o_Cr_llamada_movimiento )
    {
        $o_Cr_llamada_movimientoBN = new Cr_llamada_movimientoBN();
        if ( !is_null( $o_Cr_llamada_movimiento->IdMovimientoLlamada ) ) $o_Cr_llamada_movimientoBN->setIdMovimientoLlamada( ( integer ) $o_Cr_llamada_movimiento->IdMovimientoLlamada );
        if ( !is_null( $o_Cr_llamada_movimiento->IdCabecera ) ) $o_Cr_llamada_movimientoBN->setIdCabecera( ( integer ) $o_Cr_llamada_movimiento->IdCabecera );
        if ( !is_null( $o_Cr_llamada_movimiento->IdTelefono ) ) $o_Cr_llamada_movimientoBN->setIdTelefono( ( integer ) $o_Cr_llamada_movimiento->IdTelefono );
        if ( !is_null( $o_Cr_llamada_movimiento->IdCliente ) ) $o_Cr_llamada_movimientoBN->setIdCliente( ( integer ) $o_Cr_llamada_movimiento->IdCliente );
        if ( !is_null( $o_Cr_llamada_movimiento->IdResultado ) ) $o_Cr_llamada_movimientoBN->setIdResultado( ( integer ) $o_Cr_llamada_movimiento->IdResultado );
        if ( !is_null( $o_Cr_llamada_movimiento->Detalle ) ) $o_Cr_llamada_movimientoBN->setDetalle( $o_Cr_llamada_movimiento->Detalle );
        if ( !is_null( $o_Cr_llamada_movimiento->Fecha ) ) $o_Cr_llamada_movimientoBN->setFecha( utilTimestamp::getTimestamp( $o_Cr_llamada_movimiento->Fecha, "Y-m-d H:i:s" ) );
        if ( !is_null( $o_Cr_llamada_movimiento->Monto ) ) $o_Cr_llamada_movimientoBN->setMonto( ( float ) $o_Cr_llamada_movimiento->Monto );
        if ( !is_null( $o_Cr_llamada_movimiento->HoraMinutoFin ) ) $o_Cr_llamada_movimientoBN->setHoraMinutoFin( $o_Cr_llamada_movimiento->HoraMinutoFin );
        if ( !is_null( $o_Cr_llamada_movimiento->HoraMinutoInicio ) ) $o_Cr_llamada_movimientoBN->setHoraMinutoInicio( $o_Cr_llamada_movimiento->HoraMinutoInicio );
        if ( !is_null( $o_Cr_llamada_movimiento->TipoPago ) ) $o_Cr_llamada_movimientoBN->setTipoPago( $o_Cr_llamada_movimiento->TipoPago );
        if ( !is_null( $o_Cr_llamada_movimiento->Banco ) ) $o_Cr_llamada_movimientoBN->setBanco( $o_Cr_llamada_movimiento->Banco );
        if ( !is_null( $o_Cr_llamada_movimiento->Estado ) ) $o_Cr_llamada_movimientoBN->setEstado( $o_Cr_llamada_movimiento->Estado );
        if ( !is_null( $o_Cr_llamada_movimiento->FechaRegistro ) ) $o_Cr_llamada_movimientoBN->setFechaRegistro( utilTimestamp::getTimestamp( $o_Cr_llamada_movimiento->FechaRegistro, "Y-m-d H:i:s" ) );
        if ( !is_null( $o_Cr_llamada_movimiento->UsuarioRegistro ) ) $o_Cr_llamada_movimientoBN->setUsuarioRegistro( $o_Cr_llamada_movimiento->UsuarioRegistro );
        if ( !is_null( $o_Cr_llamada_movimiento->Eliminado ) ) $o_Cr_llamada_movimientoBN->setEliminado( ( integer ) $o_Cr_llamada_movimiento->Eliminado );
        if ( !is_null( $o_Cr_llamada_movimiento->FechaEliminado ) ) $o_Cr_llamada_movimientoBN->setFechaEliminado( utilTimestamp::getTimestamp( $o_Cr_llamada_movimiento->FechaEliminado, "Y-m-d H:i:s" ) );
        if ( !is_null( $o_Cr_llamada_movimiento->UsuarioEliminado ) ) $o_Cr_llamada_movimientoBN->setUsuarioEliminado( $o_Cr_llamada_movimiento->UsuarioEliminado );
        return $o_Cr_llamada_movimientoBN;
    }
}
?>